diff --git a/drupal7/sites/all/modules/ldap/ldap_test/LdapServerTest.class.php b/drupal7/sites/all/modules/ldap/ldap_test/LdapServerTest.class.php
index a60ce8eb..f7ffb3ae 100644
--- a/drupal7/sites/all/modules/ldap/ldap_test/LdapServerTest.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_test/LdapServerTest.class.php
@@ -109,7 +109,7 @@ class LdapServerTest extends LdapServer {
     }
 
     $watchdog_tokens = array('%user' => $userdn, '%errno' => $ldap_errno, '%error' => $ldap_error);
-    watchdog('ldap', "LDAP bind failure for user %user. Error %errno: %error", $watchdog_tokens);
+    watchdog('ldap_servers', "LDAP bind failure for user %user. Error %errno: %error", $watchdog_tokens);
     return $ldap_errno;
 
   }
@@ -238,7 +238,7 @@ class LdapServerTest extends LdapServer {
           // cn=jdoe,ou=campus accounts,dc=ad,dc=myuniversity,dc=edu
           //$pos = strpos($dn_lcase, $base_dn);
           $substring = strrev(substr(strrev($dn_lcase), 0, strlen($base_dn)));
-          $cascmp =  strcasecmp($base_dn, $substring);
+          $cascmp = strcasecmp($base_dn, $substring);
           if ($cascmp !== 0) {
 
             continue; // not in basedn
@@ -279,7 +279,7 @@ class LdapServerTest extends LdapServer {
           $filter_value = $subquery[1];
 
           $substring = strrev(substr(strrev($dn_lcase), 0, strlen($base_dn)));
-          $cascmp =  strcasecmp($base_dn, $substring);
+          $cascmp = strcasecmp($base_dn, $substring);
           if ($cascmp !== 0) {
             $match = FALSE;
             break; // not in basedn
diff --git a/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info b/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info
index 68a61487..31a747e3 100644
--- a/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info
+++ b/drupal7/sites/all/modules/ldap/ldap_test/ldap_test.info
@@ -18,9 +18,8 @@ files[] = LdapServerTest.class.php
 files[] = LdapTestFunctions.class.php
 files[] = LdapUserTestCase.class.php
 
-; Information added by Drupal.org packaging script on 2017-08-27
-version = "7.x-2.3"
+; Information added by Drupal.org packaging script on 2018-08-13
+version = "7.x-2.4"
 core = "7.x"
 project = "ldap"
-datestamp = "1503841448"
-
+datestamp = "1534201086"
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php
index dec94636..5d21a946 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConf.class.php
@@ -311,7 +311,7 @@ class LdapUserConf {
     if (!$sid || !$this->drupalAcctProvisionServer) {
       return FALSE;
     }
-    elseif ($this->ldapEntryProvisionServer == $sid) {
+    elseif ($this->drupalAcctProvisionServer == $sid) {
       return TRUE;
     }
     else {
@@ -350,7 +350,7 @@ class LdapUserConf {
         if (count(array_intersect($prov_events, $detail['prov_events']))) {
           // Add the attribute to our array.
           if ($detail['ldap_attr']) {
-            ldap_servers_token_extract_attributes($required_attributes,  $detail['ldap_attr']);
+            ldap_servers_token_extract_attributes($required_attributes, $detail['ldap_attr']);
           }
         }
       }
@@ -451,7 +451,7 @@ class LdapUserConf {
     }
     $this->synchMapping = $available_user_attrs;
 
-    cache_set('ldap_user_synch_mapping',  $this->synchMapping);
+    cache_set('ldap_user_synch_mapping', $this->synchMapping);
   }
 
   /**
@@ -619,7 +619,7 @@ class LdapUserConf {
         }
         if (!$ldap_user_prov_entry_exists) {
           $user_entity->ldap_user_prov_entries[LANGUAGE_NONE][] = array(
-            'value' =>  $ldap_user_prov_entry,
+            'value' => $ldap_user_prov_entry,
           );
 
           // Save the field without calling user_save()
@@ -776,8 +776,8 @@ class LdapUserConf {
    *   $user_edit data returned by reference
    *
    */
-  public function synchToDrupalAccount($drupal_user, &$user_edit, $prov_event = LDAP_USER_EVENT_SYNCH_TO_DRUPAL_USER, $ldap_user = NULL,  $save = FALSE) {
-    
+  public function synchToDrupalAccount($drupal_user, &$user_edit, $prov_event = LDAP_USER_EVENT_SYNCH_TO_DRUPAL_USER, $ldap_user = NULL, $save = FALSE) {
+
     $debug = array(
       'account' => $drupal_user,
       'user_edit' => $user_edit,
@@ -980,7 +980,7 @@ class LdapUserConf {
     /**
      * 4. call drupal_alter() to allow other modules to alter $ldap_user
      */
-
+    $params['account'] = $account;
     drupal_alter('ldap_entry', $ldap_user_entry, $params);
 
     return array($ldap_user_entry, $result);
@@ -1074,7 +1074,7 @@ class LdapUserConf {
       else { // create drupal account
         $this->entryToUserEdit($ldap_user, $user_edit, $ldap_server, LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER, array(LDAP_USER_EVENT_CREATE_DRUPAL_USER));
         if ($save) {
-          $watchdog_tokens = array('%drupal_username' =>  $user_edit['name']);
+          $watchdog_tokens = array('%drupal_username' => $user_edit['name']);
           if (empty($user_edit['name'])) {
             drupal_set_message(t('User account creation failed because of invalid, empty derived Drupal username.'), 'error');
             watchdog('ldap_user',
@@ -1198,17 +1198,6 @@ class LdapUserConf {
     }
 
     $drupal_username = $ldap_server->userUsernameFromLdapEntry($ldap_user['attr']);
-		if ($this->isSynched('[property.picture]', $prov_events, $direction)){
-
-			$picture = $ldap_server->userPictureFromLdapEntry($ldap_user['attr'], $drupal_username);
-
-			if ($picture){
-				$edit['picture'] = $picture;
-				if(isset($picture->md5Sum)){
-					$edit['data']['ldap_user']['init']['thumb5md'] = $picture->md5Sum;
-				}
-			}
-		}
 
     if ($this->isSynched('[property.name]', $prov_events, $direction) && !isset($edit['name']) && $drupal_username) {
       $edit['name'] = $drupal_username;
@@ -1243,6 +1232,18 @@ class LdapUserConf {
       );
     }
 
+    if ($this->isSynched('[property.picture]', $prov_events, $direction)) {
+      $picture = $ldap_server->userPictureFromLdapEntry($ldap_user['attr'], $drupal_username);
+      if ($picture) {
+        if (in_array(LDAP_USER_EVENT_CREATE_DRUPAL_USER, $prov_events)) {
+          $edit['picture'] = $picture->fid;
+        } else {
+          $edit['picture'] = $picture;
+        }
+        $edit['data']['ldap_user']['init']['thumb5md'] = $picture->md5Sum;
+      }
+    }
+
     /**
      * basic $user ldap fields
      */
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php
index 84df561f..70abb0ad 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_user/LdapUserConfAdmin.class.php
@@ -321,16 +321,16 @@ the top of this form.
 
       if ($direction == LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER) {
         $parent_fieldset = 'basic_to_drupal';
-        $description =  t('Provisioning from LDAP to Drupal Mappings:');
+        $description = t('Provisioning from LDAP to Drupal Mappings:');
       }
       elseif ($direction == LDAP_USER_PROV_DIRECTION_TO_LDAP_ENTRY) {
         $parent_fieldset = 'basic_to_ldap';
-        $description =   t('Provisioning from Drupal to LDAP Mappings:');
+        $description = t('Provisioning from Drupal to LDAP Mappings:');
       }
 
       $form[$parent_fieldset]['mappings__' . $direction] = array(
         '#type' => 'fieldset',
-        '#title' =>  $description,
+        '#title' => $description,
         '#collapsible' => TRUE,
         '#collapsed' => FALSE,
         '#description' => '',
@@ -372,7 +372,7 @@ EOT;
       if ($direction == LDAP_USER_PROV_DIRECTION_TO_LDAP_ENTRY) { // add some password notes
         $form[$parent_fieldset]['password_notes'] = array(
           '#type' => 'fieldset',
-          '#title' =>  t('Password Notes'),
+          '#title' => t('Password Notes'),
           '#collapsible' => TRUE,
           '#collapsed' => TRUE,
           'directions' => array(
@@ -382,7 +382,7 @@ EOT;
         );
         $form[$parent_fieldset]['source_drupal_token_notes'] = array(
           '#type' => 'fieldset',
-          '#title' =>  t('Source Drupal User Tokens and Corresponding Target LDAP Tokens'),
+          '#title' => t('Source Drupal User Tokens and Corresponding Target LDAP Tokens'),
           '#collapsible' => TRUE,
           '#collapsed' => TRUE,
           'directions' => array(
@@ -416,7 +416,17 @@ EOT;
   return $form;
 }
 
-
+  /**
+   * @param $sid
+   * @param $orphan_handling
+   */
+  private function checkPuidOrphans($sid, $orphan_handling) {
+    $ldap_server = ldap_servers_get_servers($sid, NULL, TRUE);
+    if ($ldap_server && empty($ldap_server->unique_persistent_attr)
+      && $orphan_handling != 'ldap_user_orphan_do_not_check') {
+      drupal_set_message(t('You\'ve configured the orphan check but are missing the required persistent user ID property.'), 'error');
+    }
+  }
 
 /**
  * validate submitted form
@@ -430,6 +440,8 @@ EOT;
     $this->populateFromDrupalForm($values, $storage);
     list($errors, $warnings) = $this->validate($values);
 
+    $this->checkPuidOrphans($values['drupalAcctProvisionServer'], $values['orphanedDrupalAcctBehavior']);
+
     // since failed mapping rows in form, don't populate ->ldapUserSynchMappings, need to validate these from values
     foreach ($values as $field => $value) {
       $parts = explode('__', $field);
@@ -457,7 +469,7 @@ EOT;
         }
         if ($direction == LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER && $row_mappings['user_attr'] == 'user_tokens') {
           $input_name = join('__', array('sm', 'user_attr', $i));
-          $errors[$input_name] =  t('User tokens not allowed when mapping to Drupal user.  Location: !row_descriptor', $tokens);
+          $errors[$input_name] = t('User tokens not allowed when mapping to Drupal user.  Location: !row_descriptor', $tokens);
         }
         if (!$row_mappings['ldap_attr']) {
           $input_name = join('__', array('sm', 'ldap_attr', $i));
@@ -490,19 +502,19 @@ EOT;
     $has_drupal_acct_prov_settings_options  = (count(array_filter($this->drupalAcctProvisionTriggers)) > 0);
 
     if (!$has_drupal_acct_prov_servers && $has_drupal_acct_prov_settings_options) {
-      $warnings['drupalAcctProvisionServer'] =  t('No Servers are enabled to provide provisioning to Drupal, but Drupal Account Provisioning Options are selected.', $tokens);
+      $warnings['drupalAcctProvisionServer'] = t('No Servers are enabled to provide provisioning to Drupal, but Drupal Account Provisioning Options are selected.', $tokens);
     }
     if ($has_drupal_acct_prov_servers && !$has_drupal_acct_prov_settings_options) {
-      $warnings['drupalAcctProvisionTriggers'] =  t('Servers are enabled to provide provisioning to Drupal, but no Drupal Account Provisioning Options are selected.  This will result in no synching happening.', $tokens);
+      $warnings['drupalAcctProvisionTriggers'] = t('Servers are enabled to provide provisioning to Drupal, but no Drupal Account Provisioning Options are selected.  This will result in no synching happening.', $tokens);
     }
 
     $has_ldap_prov_servers = (boolean)($this->ldapEntryProvisionServer);
     $has_ldap_prov_settings_options = (count(array_filter($this->ldapEntryProvisionTriggers)) > 0);
     if (!$has_ldap_prov_servers && $has_ldap_prov_settings_options) {
-      $warnings['ldapEntryProvisionServer'] =  t('No Servers are enabled to provide provisioning to ldap, but LDAP Entry Options are selected.', $tokens);
+      $warnings['ldapEntryProvisionServer'] = t('No Servers are enabled to provide provisioning to ldap, but LDAP Entry Options are selected.', $tokens);
     }
     if ($has_ldap_prov_servers && !$has_ldap_prov_settings_options) {
-      $warnings['ldapEntryProvisionTriggers'] =  t('Servers are enabled to provide provisioning to ldap, but no LDAP Entry Options are selected.  This will result in no synching happening.', $tokens);
+      $warnings['ldapEntryProvisionTriggers'] = t('Servers are enabled to provide provisioning to ldap, but no LDAP Entry Options are selected.  This will result in no synching happening.', $tokens);
     }
 
     if (isset($this->ldapUserSynchMappings)) {
@@ -560,7 +572,7 @@ EOT;
 
             if (count(array_keys($ldap_attribute_maps_in_token)) != 1) {
               $token_field_id = join('__', array('sm', 'user_tokens', $row_id));
-              $errors[$token_field_id] =  t('When provisioning to ldap, ldap attribute column must be singular token such as [cn]. %ldap_attr is not.
+              $errors[$token_field_id] = t('When provisioning to ldap, ldap attribute column must be singular token such as [cn]. %ldap_attr is not.
                 Do not use compound tokens such as "[displayName] [sn]" or literals such as "physics". Location: !row_descriptor', $tokens);
             }
 
@@ -571,20 +583,20 @@ EOT;
           $user_tokens_field_id = join('__', array('sm', 'user_tokens', $row_id));
 
           if (!$mapping['ldap_attr']) {
-            $errors[$ldap_attr_field_id] =  t('No LDAP Attribute given in !row_descriptor', $tokens);
+            $errors[$ldap_attr_field_id] = t('No LDAP Attribute given in !row_descriptor', $tokens);
           }
           if ($mapping['user_attr'] == 'user_tokens' && !$mapping['user_tokens']) {
-            $errors[$user_tokens_field_id] =  t('User tokens selected in !row_descriptor, but user tokens column empty.', $tokens);
+            $errors[$user_tokens_field_id] = t('User tokens selected in !row_descriptor, but user tokens column empty.', $tokens);
           }
 
           if (isset($mapping['prov_events']) && count($mapping['prov_events']) == 0) {
-            $warnings[$first_context_field_id] =  t('No synchronization events checked in !row_descriptor.
+            $warnings[$first_context_field_id] = t('No synchronization events checked in !row_descriptor.
               This field will not be synchronized until some are checked.', $tokens);
           }
         }
       }
       if ($to_ldap_entries_mappings_exist && !isset($mappings['[dn]'])) {
-        $errors['mappings__' . $synch_direction] =  t('Mapping rows exist for provisioning to ldap, but no ldap attribute is targetted for [dn].
+        $errors['mappings__' . $synch_direction] = t('Mapping rows exist for provisioning to ldap, but no ldap attribute is targetted for [dn].
           One row must map to [dn].  This row will have a user token like cn=[property.name],ou=users,dc=ldap,dc=mycompany,dc=com');
       }
     }
@@ -599,7 +611,7 @@ EOT;
    */
   protected function populateFromDrupalForm($values, $storage) {
     $this->drupalAcctProvisionServer = ($values['drupalAcctProvisionServer'] == 'none') ? 0 : $values['drupalAcctProvisionServer'];
-    $this->ldapEntryProvisionServer = ($values['ldapEntryProvisionServer']  == 'none') ? 0 : $values['ldapEntryProvisionServer'];
+    $this->ldapEntryProvisionServer = ($values['ldapEntryProvisionServer'] == 'none') ? 0 : $values['ldapEntryProvisionServer'];
 
     $this->drupalAcctProvisionTriggers = $values['drupalAcctProvisionTriggers'];
     $this->ldapEntryProvisionTriggers = $values['ldapEntryProvisionTriggers'];
@@ -787,7 +799,7 @@ EOT;
     }
 
     // 3. leave 4 rows for adding more mappings
-    for ($i=0; $i<4; $i++) {
+    for ($i = 0; $i < 4; $i++) {
       $this->addSynchFormRow($form, 'add', $direction, NULL, $user_attr_options, $row);
       $row++;
     }
@@ -821,18 +833,18 @@ EOT;
       '#disabled' => ($action == 'add' || $action == 'nonconfigurable'),
     );
 
-    $id =  $id_prefix . 'sm__convert__' . $row;
+    $id = $id_prefix . 'sm__convert__' . $row;
     $form[$id] = array(
       '#id' => $id,
       '#row' => $row,
       '#col' => ($direction == LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER) ? 2 : 3,
       '#type' => 'checkbox',
-      '#default_value' =>  isset($mapping['convert']) ? $mapping['convert'] : '',
+      '#default_value' => isset($mapping['convert']) ? $mapping['convert'] : '',
       '#disabled' => ($action == 'nonconfigurable'),
       '#attributes' => array('class' => array('convert')),
     );
 
-    $id =  $id_prefix . 'sm__ldap_attr__' . $row;
+    $id = $id_prefix . 'sm__ldap_attr__' . $row;
     $col = ($direction == LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER) ? 1 : 4;
     if ($action == 'nonconfigurable') {
       $form[$id] = array(
@@ -857,7 +869,7 @@ EOT;
       );
     }
 
-    $user_attr_input_id =  $id_prefix . 'sm__user_attr__' . $row;
+    $user_attr_input_id = $id_prefix . 'sm__user_attr__' . $row;
     $col = ($direction == LDAP_USER_PROV_DIRECTION_TO_DRUPAL_USER) ? 3 : 1;
     if ($action == 'nonconfigurable') {
       $form[$user_attr_input_id] = array(
@@ -880,11 +892,11 @@ EOT;
     }
 
     if ($direction == LDAP_USER_PROV_DIRECTION_TO_LDAP_ENTRY) {
-      $id =  $id_prefix . 'sm__user_tokens__' . $row;
+      $id = $id_prefix . 'sm__user_tokens__' . $row;
       $form[$id] = array(
         '#id' => $id,
         '#row' => $row,
-        '#col' =>  2,
+        '#col' => 2,
         '#type' => 'textfield',
         '#default_value' => isset($mapping['user_tokens']) ? $mapping['user_tokens'] : '',
         '#size' => 40,
@@ -917,7 +929,7 @@ EOT;
 
     foreach ($synchEvents as $prov_event => $prov_event_name) {
       $col++;
-      $id =  $id_prefix . join('__', array('sm', $prov_event, $row));
+      $id = $id_prefix . join('__', array('sm', $prov_event, $row));
       $form[$id] = array(
         '#id' => $id ,
         '#type' => 'checkbox',
@@ -1016,7 +1028,7 @@ EOT;
     $values['orphanedDrupalAcctBehaviorDescription'] = t('It is highly recommended to use the "Perform no action, but email list of orphaned accounts" for some time before considering switching to "Disable the account" options.');
 
 
-    $values['manualAccountConflictOptions'] =  array(
+    $values['manualAccountConflictOptions'] = array(
       LDAP_USER_MANUAL_ACCT_CONFLICT_REJECT => t('Reject manual creation of Drupal accounts that conflict with LDAP Accounts. This only applies to accounts created on user logon;  Account conflicts can still be generated by manually creating users that conflict with ldap users and these users will have their data synched with LDAP data.'),
       LDAP_USER_MANUAL_ACCT_CONFLICT_LDAP_ASSOCIATE => t('Associate manually created Drupal accounts with related LDAP Account if one exists.'),
       LDAP_USER_MANUAL_ACCT_CONFLICT_SHOW_OPTION_ON_FORM => t('Show option on user create form to determine how account conflict is resolved.'),
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.cron.inc b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.cron.inc
index 35e92b8b..88e1f4f7 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.cron.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.cron.inc
@@ -13,12 +13,7 @@
  * @param LdapUserConf $ldap_user_conf
  *
  * @return boolean FALSE on error or incompletion or TRUE otherwise
- *
- *  @todo need to avoid sending repeated emails
- *
- *
  */
-
 function _ldap_user_orphans($ldap_user_conf) {
 
   // return TRUE; // this is untested code
@@ -40,6 +35,9 @@ function _ldap_user_orphans($ldap_user_conf) {
 
   $query = new EntityFieldQuery();
   $query->entityCondition('entity_type', 'user')
+    ->fieldCondition('ldap_user_puid_sid', 'value', 'NULL', '!=')
+    ->fieldCondition('ldap_user_puid_property', 'value', 'NULL', '!=')
+    ->fieldCondition('ldap_user_puid', 'value', 'NULL', '!=')
     ->fieldCondition('ldap_user_current_dn', 'value', 'NULL', '!=')
     ->propertyCondition('uid', $last_uid_checked, '>')
     ->propertyOrderBy('uid', 'ASC')
@@ -47,7 +45,6 @@ function _ldap_user_orphans($ldap_user_conf) {
     ->addMetaData('account', user_load(1)); // run the query as user 1
   $result = $query->execute();
 
-  $drupal_users = array();
   $email_list = array();
   $ldap_servers = ldap_servers_get_servers(NULL, 'enabled');
   $watchdogs_sids_missing_watchdogged = array();
@@ -73,125 +70,143 @@ function _ldap_user_orphans($ldap_user_conf) {
 
   $batches = floor($user_count / LDAP_SERVERS_MAXFILTER_ORS) + 1;
   // e.g. 175 users and  50 max ldap query ors will yield 4 batches
-  for ($batch=1; $batch <= $batches; $batch++) { // e.g. 1,2,3,4
-    $filters = array();
-    $drupal_users = array();
-    /**
-     * 1. populate $drupal_users[$sid][$puid_attr][$puid]['exists']  = TRUE
-     *
-     * e.g.  first batch $i=0; $i<50; $i++
-     *       2nd batch   $i=50; $i<100; $i++
-     *       4th batch   $i=150; $i<175; $i++
-     */
-    $start = ($batch - 1)* LDAP_SERVERS_MAXFILTER_ORS; // e.g 0, 50, 100
-    $end_plus_1 = min(($batch)* LDAP_SERVERS_MAXFILTER_ORS, $user_count); // e.g. 50, 100, 150
-    $batch_uids = array_slice($uids, $start, ($end_plus_1 - $start)); // e.g. 50, 50; 100, 50
-    $accounts = entity_load('user', $batch_uids);
-
-    foreach ($accounts as $uid => $user) {
-      $sid = @$user->ldap_user_puid_sid[LANGUAGE_NONE][0]['value'];
-      $puid = @$user->ldap_user_puid[LANGUAGE_NONE][0]['value'];
-      $puid_attr = @$user->ldap_user_puid_property[LANGUAGE_NONE][0]['value'];
-      if ($sid && $puid && $puid_attr) {
-        if ($ldap_servers[$sid]->unique_persistent_attr_binary) {
-          $filters[$sid][$puid_attr][] = "($puid_attr=" . ldap_servers_binary_filter($puid) . ")";
-        }
-        else {
-          $filters[$sid][$puid_attr][] = "($puid_attr=$puid)";
-        }
-        $drupal_users[$sid][$puid_attr][$puid]['uid'] = $uid;
-        $drupal_users[$sid][$puid_attr][$puid]['exists'] = FALSE;
+  for ($batch = 1; $batch <= $batches; $batch++) {
+    $email_list = _ldap_user_orphan_process_batch($ldap_user_conf, $batch, $user_count, $uids, $ldap_servers, $watchdogs_sids_missing_watchdogged, $query, $email_list);
+  }
+
+  if (count($email_list) > 0) {
+    $site_email = variable_get('site_mail', FALSE);
+    $params = array('accounts' => $email_list);
+    if ($site_email) {
+      drupal_mail(
+        'ldap_user',
+        'orphaned_accounts',
+        $site_email,
+        language_default(),
+        $params
+      );
+    }
+  }
+
+  return TRUE;
+}
+
+/**
+ * @param $ldap_user_conf
+ * @param $batch
+ * @param $user_count
+ * @param $uids
+ * @param $ldap_servers
+ * @param $watchdogs_sids_missing_watchdogged
+ * @param $query
+ * @param $email_list
+ *
+ * @return array
+ * @throws \Exception
+ */
+function _ldap_user_orphan_process_batch($ldap_user_conf, $batch, $user_count, $uids, $ldap_servers, $watchdogs_sids_missing_watchdogged, $query, $email_list) {
+  $filters = [];
+  $drupal_users = array();
+  /**
+   * 1. populate $drupal_users[$sid][$puid_attr][$puid]['exists']  = TRUE
+   *
+   * e.g.  first batch $i=0; $i<50; $i++
+   *       2nd batch   $i=50; $i<100; $i++
+   *       4th batch   $i=150; $i<175; $i++
+   */
+  $start = ($batch - 1) * LDAP_SERVERS_MAXFILTER_ORS; // e.g 0, 50, 100
+  $end_plus_1 = min(($batch) * LDAP_SERVERS_MAXFILTER_ORS, $user_count); // e.g. 50, 100, 150
+  $batch_uids = array_slice($uids, $start, ($end_plus_1 - $start)); // e.g. 50, 50; 100, 50
+  $accounts = entity_load('user', $batch_uids);
+
+  foreach ($accounts as $uid => $user) {
+    $sid = @$user->ldap_user_puid_sid[LANGUAGE_NONE][0]['value'];
+    $puid = @$user->ldap_user_puid[LANGUAGE_NONE][0]['value'];
+    $puid_attr = @$user->ldap_user_puid_property[LANGUAGE_NONE][0]['value'];
+    if ($sid && $puid && $puid_attr) {
+      if ($ldap_servers[$sid]->unique_persistent_attr_binary) {
+        $filters[$sid][$puid_attr][] = "($puid_attr=" . ldap_servers_binary_filter($puid) . ")";
       }
       else {
-        // user with missing ldap data fields
-        // perhaps should be watchdogged?
+        $filters[$sid][$puid_attr][] = "($puid_attr=$puid)";
       }
+      $drupal_users[$sid][$puid_attr][$puid]['uid'] = $uid;
+      $drupal_users[$sid][$puid_attr][$puid]['exists'] = FALSE;
+    }
+    else {
+      // user with missing ldap data fields
+      // perhaps should be watchdogged?
     }
+  }
 
-    //2. set $drupal_users[$sid][$puid_attr][$puid]['exists'] to FALSE
-    // if entry doesn't exist
-    foreach ($filters as $sid => $puid_attrs) {
-      if (!isset($ldap_servers[$sid])) {
-        if (!isset($watchdogs_sids_missing_watchdogged[$sid])) {
-          watchdog(
-            'ldap_user',
-            'Server %sid not enabled, but needed to remove orphaned ldap users',
-            array('%sid' => $sid),
-            WATCHDOG_ERROR
-          );
-          $watchdogs_sids_missing_watchdogged[$sid] = TRUE;
-        }
-        continue;
+  //2. set $drupal_users[$sid][$puid_attr][$puid]['exists'] to FALSE
+  // if entry doesn't exist
+  foreach ($filters as $sid => $puid_attrs) {
+    if (!isset($ldap_servers[$sid])) {
+      if (!isset($watchdogs_sids_missing_watchdogged[$sid])) {
+        watchdog(
+          'ldap_user',
+          'Server %sid not enabled, but needed to remove orphaned ldap users',
+          ['%sid' => $sid],
+          WATCHDOG_ERROR
+        );
+        $watchdogs_sids_missing_watchdogged[$sid] = TRUE;
       }
-      foreach ($puid_attrs as $puid_attr => $ors) {
-        // query should look like (|(guid=3243243)(guid=3243243)(guid=3243243))
-        $ldap_filter = '(|' . join("", $ors) . ')';
-        $ldap_entries = $ldap_servers[$sid]->searchAllBaseDns($ldap_filter, array($puid_attr));
-        if ($ldap_entries === FALSE) {
-          unset($drupal_users[$sid]); // if query has error, don't remove ldap entries!
-          watchdog(
-            'ldap_user',
-            'ldap server %sid had error while querying to
+      continue;
+    }
+    foreach ($puid_attrs as $puid_attr => $ors) {
+      // query should look like (|(guid=3243243)(guid=3243243)(guid=3243243))
+      $ldap_filter = '(|' . join("", $ors) . ')';
+      $ldap_entries = $ldap_servers[$sid]->searchAllBaseDns($ldap_filter, [$puid_attr]);
+      if ($ldap_entries === FALSE) {
+        unset($drupal_users[$sid]); // if query has error, don't remove ldap entries!
+        watchdog(
+          'ldap_user',
+          'ldap server %sid had error while querying to
             deal with orphaned ldap user entries.  Please check that the ldap
             server is configured correctly.  Query; %query',
-            array('%sid' => $sid, '%query' => serialize($query)),
-            WATCHDOG_ERROR);
-          continue;
-        }
+          ['%sid' => $sid, '%query' => serialize($query)],
+          WATCHDOG_ERROR);
+        continue;
+      }
 
-        unset($ldap_entries['count']);
+      unset($ldap_entries['count']);
 
-        foreach ($ldap_entries as $i => $ldap_entry) {
-          $puid = $ldap_servers[$sid]->userPuidFromLdapEntry($ldap_entry);
-          $drupal_users[$sid][$puid_attr][$puid]['exists'] = TRUE;
-        }
+      foreach ($ldap_entries as $i => $ldap_entry) {
+        $puid = $ldap_servers[$sid]->userPuidFromLdapEntry($ldap_entry);
+        $drupal_users[$sid][$puid_attr][$puid]['exists'] = TRUE;
       }
     }
-   //3. we now have $drupal_users[$sid][$puid_attr][$puid]['exists'] = FALSE | TRUE;
-    if ($ldap_user_conf->orphanedDrupalAcctBehavior == 'ldap_user_orphan_email') {
-      global $base_url;
-    }
-    $check_time = time();
-    foreach ($drupal_users as $sid => $puid_x_puid_attrs) {
-      foreach ($puid_x_puid_attrs as $puid_attr => $puids) {
-        foreach ($puids as $puid => $user_data) {
-
-          if ($account = $accounts[$user_data['uid']]) {
-            $user_edit['ldap_user_last_checked'][LANGUAGE_NONE][0]['value'] = $check_time;
-            $account = user_save($account, $user_edit, 'ldap_user');
-            if (!$user_data['exists']) {
-                /**
-              * $ldap_user_conf->orphanedDrupalAcctBehavior will either be
-               *  'ldap_user_orphan_email' or one of the user module options:
-               *     user_cancel_block, user_cancel_block_unpublish,
-               *     user_cancel_reassign, user_cancel_delete
-               */
-              if ($ldap_user_conf->orphanedDrupalAcctBehavior == 'ldap_user_orphan_email') {
-                 $email_list[] = $account->name . "," . $account->mail . "," . $base_url . "/user/" . $account->uid . "/edit";
-              }
-              else {
-                 _user_cancel(array(), $account, $ldap_user_conf->orphanedDrupalAcctBehavior);
-              }
+  }
+  //3. we now have $drupal_users[$sid][$puid_attr][$puid]['exists'] = FALSE | TRUE;
+  if ($ldap_user_conf->orphanedDrupalAcctBehavior == 'ldap_user_orphan_email') {
+    global $base_url;
+  }
+  foreach ($drupal_users as $sid => $puid_x_puid_attrs) {
+    foreach ($puid_x_puid_attrs as $puid_attr => $puids) {
+      foreach ($puids as $puid => $user_data) {
+
+        if ($account = $accounts[$user_data['uid']]) {
+          $user_edit = [];
+          $user_edit['ldap_user_last_checked'][LANGUAGE_NONE][0]['value'] = time();
+          $account = user_save($account, $user_edit, 'ldap_user');
+          if (!$user_data['exists']) {
+            /**
+             * $ldap_user_conf->orphanedDrupalAcctBehavior will either be
+             *  'ldap_user_orphan_email' or one of the user module options:
+             *     user_cancel_block, user_cancel_block_unpublish,
+             *     user_cancel_reassign, user_cancel_delete
+             */
+            if ($ldap_user_conf->orphanedDrupalAcctBehavior == 'ldap_user_orphan_email') {
+              $email_list[] = $account->name . "," . $account->mail . "," . $base_url . "/user/" . $account->uid . "/edit";
+            }
+            else {
+              _user_cancel([], $account, $ldap_user_conf->orphanedDrupalAcctBehavior);
             }
           }
         }
       }
     }
   }
-
-  if (count($email_list) > 0) {
-    $site_email =  variable_get('site_mail', FALSE);
-    $params = array('accounts' => $email_list);
-    if ($site_email) {
-      drupal_mail(
-        'ldap_user',
-        'orphaned_accounts',
-        $site_email,
-        language_default(),
-        $params
-      );
-    }
-  }
-
-  return TRUE;
+  return $email_list;
 }
diff --git a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info
index 0f7c5f33..a3d6ae1a 100644
--- a/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info
+++ b/drupal7/sites/all/modules/ldap/ldap_user/ldap_user.info
@@ -15,19 +15,17 @@ files[] = ldap_user.functions.inc
 files[] = ldap_user.admin.inc
 files[] = ldap_user.test_form.inc
 files[] = ldap_user.theme.inc
-;files[] = ldap_user.ws.inc
+
 files[] = LdapUserConf.class.php
 files[] = LdapUserConfAdmin.class.php
 files[] = tests/ldap_user.test
 
-stylesheets[all][] = ldap_user.css
 configure = admin/config/people/ldap/user
 
 test_dependencies[] = ldap_sso:ldap_sso
 
-; Information added by Drupal.org packaging script on 2017-08-27
-version = "7.x-2.3"
+; Information added by Drupal.org packaging script on 2018-08-13
+version = "7.x-2.4"
 core = "7.x"
 project = "ldap"
-datestamp = "1503841448"
-
+datestamp = "1534201086"
